/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import java.net.*;
import ksu.cis.mom.*;
import java.io.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class UnicastServer extends Conversation
{
  public agentServer parent;
  public String command;
  public UnicastServer(
    Socket s,
    ObjectInputStream i,
    ObjectOutputStream o,
    agentServer as,
    Message m)
  {
    super(s, i, o, as, m);
    parent = as;
  }

  public void run()
  {
    int state = 0;
    boolean notDone = true;
    int result = 0;
    try
    {
      //connection = new Socket(connectionHost, connectionPort);
      //output = new ObjectOutputStream(connection.getOutputStream());
      //output.flush();
      //input = new ObjectInputStream(connection.getInputStream());
      while (notDone)
      {
        switch (state)
        {
          case 0 :
            command = (String) m.content;
            CalculatePrime cp = new CalculatePrime();
            if(m.performative.equals("calculate"))
            {
              result = cp.getPrime(Integer.parseInt(command));
              System.out.println("** Result is " + result);
            }
            else
              result = -1;
            state = 1;
            break;
          case 1 :
            Message reply = new Message();
            command = "Prime is " + result;
            reply.setPerformative("reply");
            reply.setContent(command); 
            sendMessage(reply, output);
            notDone = false;
            break;
        }
      }
      input.close();
      output.close();
      connection.close();
    }
    catch (UnknownHostException e)
    {
      parent.write("** Unknown Host exception in Client_Register.");
    }
    catch (EOFException oef)
    {
      parent.write("** Server terminated connection in Client_Register.");
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in Client_Register.");
    }
  }

}
