/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import java.awt.*;
import java.awt.event.*;

/**
 * Interface class for agent_test class
 * @author Chairoj Mekprasertvit
 *
 */
public class agent_interface extends Frame
{
  private TextField field1;
  private TextField field2;
  private TextField field3;
  private TextField field4;
  private TextArea display;
  private agent_test agent;
  
  /**
   * Constrcutor for agent_interface
   *
   */
  public agent_interface()
  {
    super("Please Wait...");
    // Initialize members
    agent = new agent_test();
    Thread t = new Thread(agent);
    t.start();
    field1 = new TextField();
    field2 = new TextField();
    field3 = new TextField();
    field4 = new TextField();
    display = new TextArea();
    // set grid 5 row and 1 columns
    setLayout (new GridLayout(5,1));
    
    //create field for outgoing unicast message.
    field1.setEnabled(false);
    field1.addActionListener
    (
      new ActionListener() 
      {
        public void actionPerformed(ActionEvent e)
        {
          agent.write("Sending Unicast");
          agent.setCommand(1, e.getActionCommand(), display);
        }
      }
    );
  
    //create field for outgoing secure unicast message.
    field2.setEnabled(false);
    field2.addActionListener
    (
      new ActionListener() 
      {
        public void actionPerformed(ActionEvent e)
        {
          agent.setCommand(2, e.getActionCommand(), display);
        }
      }
    );
    
    //create field for outgoing multicast message.
    field3.setEnabled(false);
    field3.addActionListener
    (
      new ActionListener() 
      {
        public void actionPerformed(ActionEvent e)
        {
          agent.setCommand(3, e.getActionCommand(), display);
        }
      }
    );
    
    //create field for outgoing broadcast message.
    field4.setEnabled(false);
    field4.addActionListener
    (
      new ActionListener() 
      {
        public void actionPerformed(ActionEvent e)
        {
          agent.setCommand(4, e.getActionCommand(), display);
        }
      }
    );
    add(display);
    add(field1);
    add(field2);
    add(field3);
    add(field4);
    
    setSize(300, 200);
    show();
  }
  
  public void startUI()
  {
    setTitle("Demo II: " + agent.name);
  
    field1.setEnabled(true);
    field2.setEnabled(true);
    field3.setEnabled(true);
    field4.setEnabled(true);
  }

  
  /**
   * main method
   * @param args
   */
  public static void main(String[] args)
  {
    agent_interface ai = new agent_interface();
    ai.addWindowListener
    (
      new WindowAdapter()
      {
        public void windowClosing(WindowEvent e)
        {
          System.exit(0);
        }
      }
    );
    
    ai.startUI();
  }// end of main method

}//end of class agent_interface
