/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import ksu.cis.mom.*;
import java.net.*;
import java.io.*;
import java.awt.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class multicast extends MulticastConversation
{
  public agent_test parent;
  public String command;
  public String conversation_name;
  public TextArea display;
  public multicast(
    agent_test agent,
    int m_port,
    InetAddress group,
    String command,
    TextArea display)
  {
    super(agent, group, m_port, agent.multicast_queue);
    parent = agent;
    this.command = command;
    this.display = display;
    this.conversation_name = "multicast";
  }

  public void run()
  {
    Message m = new Message();
    int state = 0;
    boolean notDone = true;
    try
    {
      while (notDone)
      {
        switch (state)
        {
          case 0 :
            m.performative = "calculate";
            m.content = command;
            startConversation(m, conversation_name, "MulticastServer");
            state = 1;
            break;
          case 1 :
            m = readMessage("multicast");
            if (m.performative.equals("reply"))
            {
              display.append((String) m.content + " from "+ m.sender +"\n");
              notDone = false;
            }
            else
              parent.write("** ERROR - did not get reply back **");

            m = readMessage("multicast");
            if (m.performative.equals("reply"))
            {
              display.append((String) m.content + " from " + m.sender +"\n");
              notDone = false;
            }
            else
              parent.write("** ERROR - did not get reply back **");
            break;
        }
      }
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in multicast conversation.");
    }
  }
}
