/*
 * Project: Applying Broadcast/Multicast/Secured Communication to agentMom
 * Department of Computing and Information Sciences
 * Kansas State University
 *
 */
package ksu.cis.test;
import ksu.cis.mom.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;

/**
 * @author Chairoj Mekprasertvit
 *
 */
public class unicast extends Conversation
{
  public agent_test parent;
  public String command;
  public TextArea display;
  public unicast(
    agent_test agent,
    String servername,
    int u_port,
    String command,
    TextArea display)
  {
    super(agent, servername, u_port);
    parent = agent;
    this.command = command;
    this.display = display;
  }

  public void run()
  {
    Message m = new Message();
    int state = 0;
    boolean notDone = true;
    try
    {
      connection = new Socket(connectionHost, connectionPort);
      output = new ObjectOutputStream(connection.getOutputStream());
      output.flush();
      input = new ObjectInputStream(connection.getInputStream());
      StringTokenizer token = new StringTokenizer(command);
      while (notDone)
      {
        switch (state)
        {
          case 0 :
            m.performative = "calculate";
            m.content = command;
            sendMessage(m, output);
            state = 1;
            break;
          case 1 :
            m = readMessage(input);
            if (m.performative.equals("reply"))
            {
              display.append((String) m.content + "\n");
              notDone = false;
            }
            else
              parent.write("** ERROR - did not get reply back **");
            break;
        }
      }
      input.close();
      output.close();
      connection.close();
    }
    catch (UnknownHostException e)
    {
      parent.write("** Unknown Host exception in unicast. " + e.toString());
    }
    catch (EOFException oef)
    {
      parent.write("** Server terminated connection in unicast. " + oef.toString());
    }
    catch (IOException e)
    {
      parent.write("** IO Exception in unicast. " + e.toString());
    }
  }
}
